// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Dirk Grunwald (grunwald@cs.uiuc.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/
#ifndef SampleStatistic_h
#define SampleStatistic_h 1

#ifdef __GNUG__
#  pragma interface
#endif

class SampleStatistic {

protected:
    double n;
    double x;
    double x2;
    double minValue, maxValue;

    static double tval(double p, double degrees_of_freedom);

public :

    SampleStatistic();
    virtual ~SampleStatistic();
    virtual void reset(); 

    virtual void operator+=(double);

    virtual void add(double);
    virtual void add(double, double);

    virtual double samples();
    virtual double mean();
    virtual double stdDev();
    virtual double var();
    virtual double min();
    virtual double max();
    virtual double sum();

    static double student_t(double samples,
			    double mean,
			    double stddev,
			    double interval
			    );

    virtual double confidence(int p_percentage);
    virtual double confidence(double p_value);

    void            error(char* msg);
};

inline
SampleStatistic::SampleStatistic()
{
    reset();
}

#if 0

#include <stddef.h>
// error handlers

//extern  void default_SampleStatistic_error_handler(char*);
//extern  one_arg_error_handler_t SampleStatistic_error_handler;

//extern  one_arg_error_handler_t 
//        set_SampleStatistic_error_handler(one_arg_error_handler_t f);
#endif

#endif
